clear
close all
load('featureMaps.mat')
clc

datas = {openEnd,corner,deadEnd,difficultOne,junctionCorner,corridor};

endNodes = input('Dost thou desire end-node detection (y/n)? ', 's');

if(endNodes=='y' || endNodes=='n')
    for i=1:6
        data = datas{i};

        points = find( (abs((diff(data(:,1))))>0.5) ==1);
        points = [0; points; size(data,1)];
        data(data(:,1)<0.05,1) = 11;

        figure(1);
        subplot(2,3,i);
        hold on;
        scatter(0,0,'k*')

        for i=1:numel(points)-1
            seg = data(points(i)+1:points(i+1),:);

            N = numel(seg(:,1));
            ddata = diff(data(:,1));
            if( (i~=1 && ddata(points(i))<-0.5) || endNodes == 'y' )
                j = 1;
            else
                j = [];
            end

            k = 0;
            while k<N
                if( seg(1,1) > 10)
                    if( endNodes == 'y' )
                        j(end) = [];
                    end
                    break
                end
                [seg, val] = splitAndMerge(seg, 0.05);

                k = k + val;
                j = [j;k];
            end
            
            if( endNodes == 'n' )
                if( i~=numel(points)-1 && ddata(points(i+1))<-0.5 && ~isempty(j))
                    j(end) = [];
                elseif( i==numel(points)-1 )
                    j(end) = [];
                end
            end

            r = data(points(i)+j,1);
            a = data(points(i)+j,2);

            y = cos(a).*r;
            x = sin(a).*r;

            scatter(x,y,'r');
        end
    end
else
    disp('Incorrect input, exiting');
end