function [vec, iprev] = splitAndMerge(vec, val)
    r = vec(:,1);
    a = vec(:,2);

    y = cos(a).*r;
    x = sin(a).*r;
    
    scatter(x,y,'g.');
    
    m = val+1;
    i = numel(r);
    while ( m > val )
        dy = (y(i)-y(1));
        dx = (x(i)-x(1));

        dist =abs( dy*x - dx*y + x(i)*y(1) - y(i)*x(1) ) / sqrt( dy^2+dx^2 );

        iprev = i;
        [m, i] = max(dist(1:i));
    end
    
    vec = vec(iprev+1:end,:);
end